@echo off

rem Set these for your as appropriate for your system
rem This directory.
set BASEDIR=C:\JavaQuat212
rem Java
set JDIR=C:\j2sdk1.4.2_09

rem These are derived from the above
set TOOLSLIB="%JDIR%\lib\tools.jar"
set JAR=%JDIR%\bin\jar
set JAVAC="%JDIR%\bin\javac"
set SRCDIR=JavaQuat20
set LOOPDIR=%SRCDIR%\FractalLoops
set ENCDIR=%SRCDIR%\GIFEncoderPkg
set DECDIR=%SRCDIR%\GIFDecoderPkg

set JFLAGS=-g

rem NOTE: Keep the line below formatted exactly as is: "VERSION=version",
rem       left-justified, with no trailing spaces.
set VERSION=2.12

set FILEVERSION=214

set JAR_DEST=JavaQuat%FILEVERSION%.jar
set MANIFESTFILE=MANIFEST.MF

rem Delete old class files
pushd %SRCDIR%
del *.class
echo Making Version.java...
del Version.java
echo // This file is generated by the build.bat file.  Do not edit. >> Version.java
echo package JavaQuat20; > Version.java
echo class Version { >> Version.java
echo     static final String value = "%VERSION% (for %JDIR%)"; >> Version.java
echo } >> Version.java
popd

rem now in  %BASEDIR%

echo COMPILING...
rem %JAVAC% %JFLAGS% -d classes -classpath %TOOLSLIB% %SRC%
%JAVAC% %JFLAGS% -d classFiles -classpath "%TOOLSLIB%;." %SRCDIR%\FractalLoops\Cpx2*.java

if %ERRORLEVEL% == 0 GOTO COMPILE2
echo Compile 1 FAILED: %ERRORLEVEL%
GOTO END

:COMPILE2
echo COMPILE2
%JAVAC% %JFLAGS% -d classFiles -classpath "%TOOLSLIB%;." %SRCDIR%\FractalLoops\*.java

if %ERRORLEVEL% == 0 GOTO COMPILE3
echo Compile 2 FAILED: %ERRORLEVEL%
GOTO END

:COMPILE3
echo COMPILE3
%JAVAC% %JFLAGS% -d classFiles -classpath "%TOOLSLIB%;." %SRCDIR%\GIFDecoderPkg\GIFDecoder.java

if %ERRORLEVEL% == 0 GOTO COMPILE4
echo Compile 3 FAILED: %ERRORLEVEL%
GOTO END

:COMPILE4
echo COMPILE4
%JAVAC% %JFLAGS% -d classFiles -classpath "%TOOLSLIB%;." %SRCDIR%\GIFEncoderPkg\GIFEncoder.java

if %ERRORLEVEL% == 0 GOTO COMPILE5
echo Compile 4 FAILED: %ERRORLEVEL%
GOTO END

:COMPILE5
echo COMPILE5
%JAVAC% %JFLAGS% -d classFiles -classpath "%TOOLSLIB%;." %SRCDIR%\JQStarter.java %SRCDIR%\JQApplet.java
if %ERRORLEVEL% == 0 GOTO JARIT1
echo Compile 5 FAILED: %ERRORLEVEL%
GOTO END

:JARIT1

echo JAR-ing...
del %JAR_DEST%
"%JAR%" cmf %MANIFESTFILE% %JAR_DEST% -C classFiles JavaQuat20

if %ERRORLEVEL% == 0 GOTO LASTPART
echo Jar FAILED: %ERRORLEVEL%
GOTO END

:LASTPART

rem echo Installing...
pushd c:\WINDOWS\system32
del c:\WINDOWS\system32\JavaQuat214.bat
echo %JDIR%\bin\java -Xdebug -Xnoagent "-Djava.compiler=NONE" "-Xrunjdwp:transport=dt_shmem,server=y" -jar %BASEDIR%\%JAR_DEST% > c:\WINDOWS\system32\JavaQuat214_debug.bat
echo %JDIR%\bin\java -jar %BASEDIR%\%JAR_DEST% > c:\WINDOWS\system32\JavaQuat214.bat
popd

echo END
:END
pause
