@echo off

rem Set these for your as appropriate for your system
set JDIR=C:\j2sdk1.4.2_06
set TOOLSLIB="C:\j2sdk1.4.2_06\lib\tools.jar"
set BASEDIR=C:\JavaQuat210\JQJoiner

rem These are derived from the above
set JAR=%JDIR%\bin\jar
set JAVAC="%JDIR%\bin\javac"
set LIBDIR=%BASEDIR%\lib
set TIFFDIR=%BASEDIR%\TIFFEncoderPkg
set ENCDIR=%BASEDIR%\GIFEncoderPkg
set DECDIR=%BASEDIR%\GIFDecoderPkg

set JFLAGS=-g -deprecation

rem Delete old class files

pushd %ENCDIR%
del *.class
popd
pushd %DECDIR%
del *.class
popd
pushd %TIFFDIR%
del *.class
popd

del *.class

rem ----------------  now in  %BASEDIR%

echo COMPILING...
rem %JAVAC% %JFLAGS% -d classes -classpath %TOOLSLIB% %SRC%
%JAVAC% %JFLAGS% -d classFiles -classpath "%TOOLSLIB%;." %TIFFDIR%\*.java

if %ERRORLEVEL% == 0 GOTO COMPILE2
echo Compile Tiff FAILED: %ERRORLEVEL%
popd
GOTO END

:COMPILE2
echo COMPILE2
%JAVAC% %JFLAGS% -d classFiles -classpath "classFiles;%TOOLSLIB%;." %DECDIR%\*.java

if %ERRORLEVEL% == 0 GOTO COMPILE3
echo Compile Encoder FAILED: %ERRORLEVEL%
popd
GOTO END

:COMPILE3
echo COMPILE3
%JAVAC% %JFLAGS% -d classFiles -classpath "classFiles;%TOOLSLIB%;." %ENCDIR%\*.java

if %ERRORLEVEL% == 0 GOTO COMPILE4
echo Compile Decoder FAILED: %ERRORLEVEL%
popd
GOTO END

:COMPILE4
echo COMPILE4
%JAVAC% %JFLAGS% -d classFiles -classpath "classFiles;..;%TOOLSLIB%;." *.java

if %ERRORLEVEL% == 0 GOTO JAR1
echo Compile main dir FAILED: %ERRORLEVEL%
popd
GOTO END

:JAR1
echo JAR-ing RectJoiner ...
copy MANIFEST.REC MANIFEST.MF
del %JARFILE%
"%JAR%" cmvf MANIFEST.MF RectJoiner.jar -C classFiles JQJoiner

if %ERRORLEVEL% == 0 GOTO JARIT2
echo Jar RectJoiner FAILED: %ERRORLEVEL%
popd
GOTO END

:JARIT2
echo JAR-ing ChunkJoiner ...
copy MANIFEST.CHUNK MANIFEST.MF
"%JAR%" cmvf MANIFEST.MF ChunkJoiner.jar -C classFiles JQJoiner

if %ERRORLEVEL% == 0 GOTO JARIT3
echo Jar 2 FAILED: %ERRORLEVEL%
popd
GOTO END

:JARIT3
echo JAR-ing ColorMapRep ...
copy MANIFEST.CMREP MANIFEST.MF
"%JAR%" cmvf MANIFEST.MF ColorMapReplace.jar -C classFiles JQJoiner

if %ERRORLEVEL% == 0 GOTO END
echo Jar 3 FAILED: %ERRORLEVEL%
popd
GOTO END

:END
pause

echo END
:END
pause
