package JQJoiner;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import JavaQuat20.*;


public class CMRepFrame extends Frame
{
  static final String horizString = "Horiz.";
  static final String vertString = "Vert.";

  private CMRepFrame self_;
  private TextField cmSourceField_;
  private TextField pixSourceField_;
  private TextField lastField_;
  private TextArea msgArea_;
  private TextField destinationField_;
  
  private int first_ = 0;
  private int last_ = 0;
  private boolean horiz_p_ = true;

  public CMRepFrame ()
  {
    super("Color Map Replace");
    setBackground(Color.lightGray);
    Vector smallAlpha = new Vector(45);
    self_ = this;
    smallAlpha.addElement(this);
    
    cmSourceField_ = new TextField();
    cmSourceField_.setBackground(Color.white);
    
    pixSourceField_ = new TextField();
    pixSourceField_.setBackground(Color.white);
        
    msgArea_ = new TextArea();
    msgArea_.setBackground(Color.white);
      
    destinationField_ = new TextField();
    destinationField_.setBackground(Color.white);
    
    Button browseCMSourceButton = new Button("Browse...");
    browseCMSourceButton.addActionListener(new brCMLNR());
    
    Button browsePixSourceButton = new Button("Browse...");
    browsePixSourceButton.addActionListener(new brPixLNR());
    
    Button browseDestButton = new Button("Browse...");
    browseDestButton.addActionListener(new brDestLNR());
    
    Button doItButton = new Button("OK, Replace ColorMap.");
    doItButton.addActionListener(new doItLNR());
    
    addWindowListener(new MyWindowLNR());
    
    /* --------------- Menu Bar ---------------- */
    MenuBar menuBar = new MenuBar();
    setMenuBar(menuBar);
    
    /* --------------- File Menu ---------------- */
    Menu fileMenu = new Menu("File", true); // true for tearoff.
    menuBar.add(fileMenu);
    
    MenuItem quitMI = new MenuItem("Quit");
    quitMI.addActionListener(new quitLNR());
    quitMI.setShortcut(new MenuShortcut(KeyEvent.VK_Q));
    fileMenu.add(quitMI);
    
    /*  ---------------------- END MENU ------------------ */
    
    
    setLayout(new GridLayout(5, 1, 5, 0));
    
    Panel quarter1 = new Panel();
    add(quarter1);
    quarter1.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter1.add(new Label("Color Map Source Pathname.", Label.CENTER));
    Panel cmSourcePanel = new Panel();
    quarter1.add(cmSourcePanel);
    cmSourcePanel.setLayout(new BorderLayout(5, 5));
    cmSourcePanel.add("East", browseCMSourceButton);
    cmSourcePanel.add("Center", cmSourceField_);
    
    
    Panel quarter2 = new Panel();
    add(quarter2);
    quarter2.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter2.add(new Label("Picture Pathname.", Label.CENTER));
    Panel pixSourcePanel = new Panel();
    quarter2.add(pixSourcePanel);
    pixSourcePanel.setLayout(new BorderLayout(5, 5));
    pixSourcePanel.add("East", browsePixSourceButton);
    pixSourcePanel.add("Center", pixSourceField_);

    
    add(msgArea_);
    
    
    Panel quarter3 = new Panel();
    add(quarter3);
    quarter3.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter3.add(new Label("Destination pathname.", Label.CENTER));
    Panel destPanel = new Panel();
    quarter3.add(destPanel);
    destPanel.setLayout(new BorderLayout(5, 5));
    destPanel.add("East", browseDestButton);
    destPanel.add("Center", destinationField_);
    
    
    Panel quarter4 = new Panel();
    add(quarter4);
    quarter4.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter4.add(new Label(""));
    Panel doItPanel = new Panel();
    quarter4.add(doItPanel);
    doItPanel.setLayout(new BorderLayout(5, 5));
    doItPanel.add("West", doItButton);
    doItPanel.add("Center", new Label(""));
    
    
    String [] preferredFonts = {"Courier", "courier", 
                                "Dialog", "dialog", 
                                "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 10);
    setter.setComponentFonts(smallAlpha);

    setSize(400, 200);
    setResizable(true);
    show();
  }

  /* ---------------- Functionality -------------------- */

  public void message (String arg)
  {
    msgArea_.append(arg + "\n");
  }
  
  public void clearMessages ()
  {
    msgArea_.setText("");
  }
  
  public String pathFromDialog (boolean existing_p)
  {
     FileDialog fd;
     fd = new FileDialog(this, null, 
                         (existing_p ? FileDialog.LOAD : FileDialog.SAVE));

     try {
       fd.show();
     } catch (Throwable e) {
       return null;
     }
     //Allow for variation in Java implementations
     String dir = fd.getDirectory();
     if (dir == null) {
       // User hit cancel probably.
       return null;
     }
     boolean haslash = dir.charAt(dir.length() - 1) == '/';
     String pathname_ = (dir + (haslash ? "" : "/") + fd.getFile());
     return pathname_;
  }


 
  /* ---------------- Listeners -------------------- */

  class MyWindowLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {

    }

    public void windowClosing (WindowEvent e)
    {

    }

    public void windowClosed (WindowEvent e)
    {

    }

    public void windowIconified (WindowEvent e)
    {

    }

    public void windowDeiconified (WindowEvent e)
    {
      
    }

    public void windowActivated (WindowEvent e)
    {
  
    }

    public void windowDeactivated (WindowEvent e)
    {
      
    }
  }
  
   /* ------------ File Menu ---------------- */
   
  class quitLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      System.exit(0);
    }
  }

    // firstLNR lastLNR || brSrcLNR hvLNR brDestLNR doItLNR


   /* ------------ Setting the D Axis ---------------- */
   
  class brCMLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog(true);
      if (path1 != null)
        cmSourceField_.setText(path1);
    }
  }

  class brPixLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog(true);
      if (path1 != null)
        pixSourceField_.setText(path1);
    }
  }

  class brDestLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog(false);
      if (path1 != null)
        destinationField_.setText(path1);
    }
  }


  class doItLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String cmPathname = cmSourceField_.getText();
      String pixPathname = pixSourceField_.getText();
      String destPathname = destinationField_.getText();
      if (cmPathname == null) {
        message("Color Map Pathname is blank.");
        return;
      }
      if (pixPathname == null) {
        message("Picture Pathname is blank.");
        return;
      }
      if (destPathname == null) {
        message("Destination Pathname is blank.");
        return;
      }
      
      CMReplacer cmr = new CMReplacer(cmPathname, pixPathname, destPathname);
      cmr.replaceColorMap();
      System.gc();
    }
  }

  /* -------------- Entry Point ------------------ */
  
  public static void main(String[] args)
    // 
  {
     new CMRepFrame();
  }

  
}
