package JQJoiner;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
import JavaQuat20.*;


public class ChunckFrame extends Frame implements Messenger
{
  static final String horizString = "Horiz.";
  static final String vertString = "Vert.";

  private ChunckFrame self_;
  private TextField sourceField_;
  private TextField firstHField_;
  private TextField lastHField_;
  private TextField firstVField_;
  private TextField lastVField_;
  private TextField yChunkField_;
  private TextField xChunkField_;
  private TextArea msgArea_;
  private TextField destinationField_;
//  private Button hvButton_;
  private ChunckJoiner sqJoiner_ = null;
  
  private int hFirst_ = 0;
  private int hLast_ = 0;
  private int vFirst_ = 0;
  private int vLast_ = 0;
  private int yChunk_ = 0;
  private int xChunk_ = 0;
//  private boolean horiz_p_ = true;

  public ChunckFrame ()
  {
    super("JQ Rectangular Panel Joiner +");
    setBackground(Color.lightGray);
    Vector smallAlpha = new Vector(45);
    self_ = this;
    smallAlpha.addElement(this);
    
    sourceField_ = new TextField();
    sourceField_.setBackground(Color.white);
    
    firstHField_ = new TextField("0");
    firstHField_.addTextListener(new firstHLNR());
    firstHField_.setBackground(Color.white);
    
    lastHField_ = new TextField("0");
    lastHField_.addTextListener(new lastHLNR());
    lastHField_.setBackground(Color.white);
    
    firstVField_ = new TextField("0");
    firstVField_.addTextListener(new firstVLNR());
    firstVField_.setBackground(Color.white);
    
    lastVField_ = new TextField("0");
    lastVField_.addTextListener(new lastVLNR());
    lastVField_.setBackground(Color.white);
    
    yChunkField_ = new TextField("0");
    yChunkField_.addTextListener(new yChunkLNR());
    yChunkField_.setBackground(Color.white);
    
    xChunkField_ = new TextField("0");
    xChunkField_.addTextListener(new xChunkLNR());
    xChunkField_.setBackground(Color.white);
    
    msgArea_ = new TextArea();
    msgArea_.setBackground(Color.white);
      
    destinationField_ = new TextField();
    destinationField_.setBackground(Color.white);
    
    Button browseSourceButton = new Button("Browse...");
    browseSourceButton.addActionListener(new brSrcLNR());
    
//    hvButton_ = new Button(horizString);
//    hvButton_.addActionListener(new hvLNR());
    
    Button browseDestButton = new Button("Browse...");
    browseDestButton.addActionListener(new brDestLNR());
    
    Button doItButton = new Button("OK, Join Panels.");
    doItButton.addActionListener(new doItLNR());
    
    addWindowListener(new MyWindowLNR());
    
    /* --------------- Menu Bar ---------------- */
    MenuBar menuBar = new MenuBar();
    setMenuBar(menuBar);
    
    /* --------------- File Menu ---------------- */
    Menu fileMenu = new Menu("File", true); // true for tearoff.
    menuBar.add(fileMenu);
    
    MenuItem stopMI = new MenuItem("Abort");
    stopMI.addActionListener(new ChStopLNR());
    stopMI.setShortcut(new MenuShortcut(KeyEvent.VK_A));
    fileMenu.add(stopMI);

    MenuItem quitMI = new MenuItem("Quit");
    quitMI.addActionListener(new quitLNR());
    quitMI.setShortcut(new MenuShortcut(KeyEvent.VK_Q));
    fileMenu.add(quitMI);
    
    /*  ---------------------- END MENU ------------------ */
    
    
    setLayout(new GridLayout(5, 1, 5, 0));
    
    Panel quarter1 = new Panel();
    add(quarter1);
    quarter1.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter1.add(new Label("Source: +s where Y varies, *s for X. (e.g. <file>y++-x**)", Label.CENTER));
    Panel sourcePanel = new Panel();
    quarter1.add(sourcePanel);
    sourcePanel.setLayout(new BorderLayout(5, 5));
    sourcePanel.add("East", browseSourceButton);
    sourcePanel.add("Center", sourceField_);
    
    
    Panel quarter2 = new Panel();
    add(quarter2);
    quarter2.setLayout(new GridLayout(1, 4, 10, 0));
    
    Panel q2third1 = new Panel();
    q2third1.setLayout(new GridLayout(2, 1, 0, 5));
    q2third1.add(new Label("First *", Label.CENTER));
    q2third1.add(firstHField_);
    
    Panel q2third2 = new Panel();
    q2third2.setLayout(new GridLayout(2, 1, 0, 5));
    q2third2.add(new Label("Last *", Label.CENTER));
    q2third2.add(lastHField_);
    
    Panel q2third3 = new Panel();
    q2third3.setLayout(new GridLayout(2, 1, 0, 5));
    q2third3.add(new Label("First +", Label.CENTER));
    q2third3.add(firstVField_);
    
    Panel q2third4 = new Panel();
    q2third4.setLayout(new GridLayout(2, 1, 0, 5));
    q2third4.add(new Label("Last +", Label.CENTER));
    q2third4.add(lastVField_);
    
    quarter2.add(q2third3);
    quarter2.add(q2third4);
    quarter2.add(q2third1);
    quarter2.add(q2third2);

    
    add(msgArea_);
    
    
    Panel quarter3 = new Panel();
    add(quarter3);
    quarter3.setLayout(new GridLayout(2, 1, 0, 0));
    
    Panel halves3 = new Panel();
    halves3.setLayout(new GridLayout(1, 2, 0, 0));
    halves3.add(new Label("Destination path.  Y & X Chunks->", Label.CENTER));
    
    Panel rightQuarters3 = new Panel();
    rightQuarters3.setLayout(new GridLayout(1, 2, 0, 0));
    halves3.add(rightQuarters3);
    
    rightQuarters3.add(yChunkField_);
    rightQuarters3.add(xChunkField_);
    
    quarter3.add(halves3);
    Panel destPanel = new Panel();
    quarter3.add(destPanel);
    destPanel.setLayout(new BorderLayout(5, 5));
    destPanel.add("East", browseDestButton);
    destPanel.add("Center", destinationField_);
    
    
    Panel quarter4 = new Panel();
    add(quarter4);
    quarter4.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter4.add(new Label(""));
    Panel doItPanel = new Panel();
    quarter4.add(doItPanel);
    doItPanel.setLayout(new BorderLayout(5, 5));
    doItPanel.add("West", doItButton);
    doItPanel.add("Center", new Label(""));
    
    
    String [] preferredFonts = {"Courier", "courier", 
                                "Dialog", "dialog", 
                                "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 10);
    setter.setComponentFonts(smallAlpha);

    setSize(500, 250);
    setResizable(true);
    show();
  }

  /* ---------------- Functionality -------------------- */

  public void message (String arg)
  {
    msgArea_.append(arg + "\n");
  }
  
  public void clearMessages ()
  {
    msgArea_.setText("");
  }
  
  public String pathFromDialog ()
  {
     FileDialog fd;
     fd = new FileDialog(this, null, FileDialog.SAVE);

     try {
       fd.show();
     } catch (Throwable e) {
       return null;
     }
     //Allow for variation in Java implementations
     String dir = fd.getDirectory();
     if (dir == null) {
       // User hit cancel probably.
       return null;
     }
     boolean haslash = dir.charAt(dir.length() - 1) == '/';
     String pathname_ = (dir + (haslash ? "" : "/") + fd.getFile());
     return pathname_;
  }


 
  /* ---------------- Listeners -------------------- */

  class MyWindowLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {

    }

    public void windowClosing (WindowEvent e)
    {

    }

    public void windowClosed (WindowEvent e)
    {

    }

    public void windowIconified (WindowEvent e)
    {

    }

    public void windowDeiconified (WindowEvent e)
    {
      
    }

    public void windowActivated (WindowEvent e)
    {
  
    }

    public void windowDeactivated (WindowEvent e)
    {
      
    }
  }
  
   /* ------------ File Menu ---------------- */
   
  class ChStopLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      if (sqJoiner_ != null) {
        sqJoiner_.abortJoin();
      }
    }
  }
   
  class quitLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      System.exit(0);
    }
  }

    // firstLNR lastLNR || brSrcLNR hvLNR brDestLNR doItLNR


   /* ------------ Pathname Listeners ---------------- */
   
  class brSrcLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog();
      if (path1 != null)
        sourceField_.setText(path1);
    }
  }

  class brDestLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog();
      if (path1 != null)
        destinationField_.setText(path1);
    }
  }

  class doItLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      sqJoiner_ = new ChunckJoiner(sourceField_.getText(),
                                   vFirst_, vLast_, hFirst_, hLast_, yChunk_, xChunk_,
                                   destinationField_.getText());
      sqJoiner_.prep(self_);
      Thread runner = new Thread(sqJoiner_);
      runner.start();
    }
  }

  class firstHLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        hFirst_ = new Integer(firstHField_.getText()).intValue();
        firstHField_.setForeground(Color.black);
        //message("hFirst_ set to " + hFirst_);
      } catch (Throwable except) {
        firstHField_.setForeground(Color.red);
      }
    }
  }
  
  class lastHLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        hLast_ = new Integer(lastHField_.getText()).intValue();
        lastHField_.setForeground(Color.black);
        //message("hLast_ set to " + hLast_);
      } catch (Throwable except) {
        lastHField_.setForeground(Color.red);
      }
    }
  }
  
  class firstVLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        vFirst_ = new Integer(firstVField_.getText()).intValue();
        firstVField_.setForeground(Color.black);
        //message("vFirst_ set to " + vFirst_);
      } catch (Throwable except) {
        firstVField_.setForeground(Color.red);
      }
    }
  }
  
  class lastVLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        vLast_ = new Integer(lastVField_.getText()).intValue();
        lastVField_.setForeground(Color.black);
        //message("vLast_ set to " + vLast_);
      } catch (Throwable except) {
        lastVField_.setForeground(Color.red);
      }
    }
  }
  
  class yChunkLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        yChunk_ = new Integer(yChunkField_.getText()).intValue();
        yChunkField_.setForeground(Color.black);
      } catch (Throwable except) {
        yChunkField_.setForeground(Color.red);
      }
    }
  }
  
  class xChunkLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        xChunk_ = new Integer(xChunkField_.getText()).intValue();
        xChunkField_.setForeground(Color.black);
      } catch (Throwable except) {
        xChunkField_.setForeground(Color.red);
      }
    }
  }
  
  /* -------------- Entry Point ------------------ */
  
  public static void main(String[] args)
    // 
  {
     new ChunckFrame();
  }

  
}
