package JQJoiner;

import java.util.*;

public class PathVector extends Vector
{
  public PathVector (int index1, int indexN, String pathname, String wildcard)
  {
    super();
    int firstStarIndex = pathname.indexOf(wildcard);
    int lastStarIndex = pathname.lastIndexOf(wildcard);
    int digitSpaces = lastStarIndex - firstStarIndex + 1;
    int requiredDigitSpaces = 1;
    if (indexN >= index1 && firstStarIndex > 0) {
      if (indexN > 0) {
        requiredDigitSpaces = (int)Math.floor(Math.log(indexN) / Math.log(10.0)) + 1;
      }
      if (index1 < 0) {
        int temp = (int)Math.floor(Math.log(-index1) / Math.log(10.0)) + 2;
        requiredDigitSpaces = Math.max(requiredDigitSpaces, temp);
      }
      try {
        String beginPath = pathname.substring(0, firstStarIndex);
        String endPath = pathname.substring(lastStarIndex + 1);
        if (requiredDigitSpaces <= digitSpaces && index1 <= indexN) {
          for (int i = index1; i <= indexN; i++) {
            this.addElement(beginPath + zeroPaddedIntString(i, digitSpaces) + endPath);
          }
        }
      } catch (Throwable except1) {
        System.err.println("PathVector constructor: " + except1);
      }
    } else {
      // User may want multiple copies of the same image.
      for (int i = index1; i <= indexN; i++) {
        this.addElement(pathname);
      }
    }
  }
  
  private String zeroPaddedIntString (int valueNow, int max_digits)
  {
    StringBuffer buf = new StringBuffer(8);
    int digits_now;
    if (valueNow == 0) {
      digits_now = 1; //Both these numbers are really the number of digits.
    } else if (valueNow < 0) {
      digits_now = 2 + (int)Math.floor(Math.log(-valueNow) / Math.log(10.0));
    } else {
      digits_now = (int)Math.floor(Math.log(valueNow) / Math.log(10.0)) + 1;
    }
    for (int i = 0; i < max_digits - digits_now; i++) {
      buf.append('0');
    }
    buf.append(valueNow);
    return buf.toString();
  }
}
