package JQJoiner;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;
// import JavaQuat20.*;
import JQJoiner.TIFFEncoderPkg.*;


public class RectFrame extends Frame implements Messenger
{
  private RectFrame self_;
  private TextField sourceField_;
  private TextField firstHField_;
  private TextField lastHField_;
  private TextField firstVField_;
  private TextField lastVField_;
  private TextArea msgArea_;
  private TextField destinationField_;
  private RectJoiner sqJoiner_ = null;
  
  private int hFirst_ = 0;
  private int hLast_ = 0;
  private int vFirst_ = 0;
  private int vLast_ = 0;
  
  private boolean UseTiffP_ = false;
  private int TIFFCompression_ = TIFFEncoder.PACKBITS;
  private int resolution_ = 72;
  private String copyRightNotice_ = null;
  private int tiffRowsPerStrip_ = 0;
  private CheckboxMenuItem PkBtMI_ = null;
  private CheckboxMenuItem NoCmpMI_ = null;
  
  public RectFrame ()
  {
    super("JQ Rectangular Panel Joiner");
    setBackground(Color.lightGray);
    Vector smallAlpha = new Vector(45);
    self_ = this;
    smallAlpha.addElement(this);
    
    sourceField_ = new TextField();
    sourceField_.setBackground(Color.white);
    
    firstHField_ = new TextField("0");
    firstHField_.addTextListener(new firstHLNR());
    firstHField_.setBackground(Color.white);
    
    lastHField_ = new TextField("0");
    lastHField_.addTextListener(new lastHLNR());
    lastHField_.setBackground(Color.white);
    
    firstVField_ = new TextField("0");
    firstVField_.addTextListener(new firstVLNR());
    firstVField_.setBackground(Color.white);
    
    lastVField_ = new TextField("0");
    lastVField_.addTextListener(new lastVLNR());
    lastVField_.setBackground(Color.white);
    
    msgArea_ = new TextArea();
    msgArea_.setBackground(Color.white);
      
    destinationField_ = new TextField();
    destinationField_.setBackground(Color.white);
    
    Button browseSourceButton = new Button("Browse...");
    browseSourceButton.addActionListener(new brSrcLNR());
    
    Button browseDestButton = new Button("Browse...");
    browseDestButton.addActionListener(new brDestLNR());
    
    Button doItButton = new Button("OK, Join Panels.");
    doItButton.addActionListener(new doItLNR());
    
    addWindowListener(new MyWindowLNR());
    
    /* --------------- Menu Bar ---------------- */
    MenuBar menuBar = new MenuBar();
    setMenuBar(menuBar);
    
    /* --------------- File Menu ---------------- */
    Menu fileMenu = new Menu("File", true); // true for tearoff.
    menuBar.add(fileMenu);
    
    MenuItem stopMI = new MenuItem("Abort");
    stopMI.addActionListener(new stopLNR());
    stopMI.setShortcut(new MenuShortcut(KeyEvent.VK_A));
    fileMenu.add(stopMI);
    
    MenuItem quitMI = new MenuItem("Quit");
    quitMI.addActionListener(new quitLNR());
    quitMI.setShortcut(new MenuShortcut(KeyEvent.VK_Q));
    fileMenu.add(quitMI);
    
    /* --------------- Tiff Menu ---------------- */
    Menu tiffMenu = new Menu("TIFF Options", true); // true for tearoff.
    menuBar.add(tiffMenu);

    CheckboxMenuItem tiffPMI = new CheckboxMenuItem("Write TIFF?");
    tiffPMI.addItemListener(new TiffPLNR());
    tiffPMI.setState(false);
    tiffMenu.add(tiffPMI);
    
    Menu compMenu = new Menu("Set Compression", true); // true for tearoff.
    tiffMenu.add(compMenu);
      PkBtMI_ = new CheckboxMenuItem("PackBits");
      PkBtMI_.addItemListener(new PkBCmpLNR());
      PkBtMI_.setState(true);
      compMenu.add(PkBtMI_);
    
      NoCmpMI_ = new CheckboxMenuItem("No Compressoin");
      NoCmpMI_.addItemListener(new NoCmpLNR());
      NoCmpMI_.setState(false);
      compMenu.add(NoCmpMI_);
    
    MenuItem mi1 = new MenuItem("Resolution...");
    mi1.addActionListener(new ResLNR());
    mi1.setShortcut(new MenuShortcut(KeyEvent.VK_R));
    tiffMenu.add(mi1);

    mi1 = new MenuItem("Set Copyright Notice...");
    mi1.addActionListener(new CRtLNR());
    mi1.setShortcut(new MenuShortcut(KeyEvent.VK_N));
    tiffMenu.add(mi1);

    mi1 = new MenuItem("Set Rows per Strip...");
    mi1.addActionListener(new RwStrpLNR());
    mi1.setShortcut(new MenuShortcut(KeyEvent.VK_S));
    tiffMenu.add(mi1);

    /*  ---------------------- END MENU ------------------ */
    
    
    setLayout(new GridLayout(5, 1, 5, 0));
    
    Panel quarter1 = new Panel();
    add(quarter1);
    quarter1.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter1.add(new Label("Source: +s where Y varies, *s for X. (e.g. <file>y++-x**)", Label.CENTER));
    Panel sourcePanel = new Panel();
    quarter1.add(sourcePanel);
    sourcePanel.setLayout(new BorderLayout(5, 5));
    sourcePanel.add("East", browseSourceButton);
    sourcePanel.add("Center", sourceField_);
    
    
    Panel quarter2 = new Panel();
    add(quarter2);
    quarter2.setLayout(new GridLayout(1, 4, 10, 0));
    
    Panel q2third1 = new Panel();
    q2third1.setLayout(new GridLayout(2, 1, 0, 5));
    q2third1.add(new Label("First *", Label.CENTER));
    q2third1.add(firstHField_);
    
    Panel q2third2 = new Panel();
    q2third2.setLayout(new GridLayout(2, 1, 0, 5));
    q2third2.add(new Label("Last *", Label.CENTER));
    q2third2.add(lastHField_);
    
    Panel q2third3 = new Panel();
    q2third3.setLayout(new GridLayout(2, 1, 0, 5));
    q2third3.add(new Label("First +", Label.CENTER));
    q2third3.add(firstVField_);
    
    Panel q2third4 = new Panel();
    q2third4.setLayout(new GridLayout(2, 1, 0, 5));
    q2third4.add(new Label("Last +", Label.CENTER));
    q2third4.add(lastVField_);
    
    quarter2.add(q2third3);
    quarter2.add(q2third4);
    quarter2.add(q2third1);
    quarter2.add(q2third2);

    
    add(msgArea_);
    
    
    Panel quarter3 = new Panel();
    add(quarter3);
    quarter3.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter3.add(new Label("Destination pathname.", Label.CENTER));
    Panel destPanel = new Panel();
    quarter3.add(destPanel);
    destPanel.setLayout(new BorderLayout(5, 5));
    destPanel.add("East", browseDestButton);
    destPanel.add("Center", destinationField_);
    
    
    Panel quarter4 = new Panel();
    add(quarter4);
    quarter4.setLayout(new GridLayout(2, 1, 0, 0));
    
    quarter4.add(new Label(""));
    Panel doItPanel = new Panel();
    quarter4.add(doItPanel);
    doItPanel.setLayout(new BorderLayout(5, 5));
    doItPanel.add("West", doItButton);
    doItPanel.add("Center", new Label(""));
    
    
    String [] preferredFonts = {"Courier", "courier", 
                                "Dialog", "dialog", 
                                "Times", "times"};
    FontSetter setter = new FontSetter(preferredFonts, Font.BOLD, 10);
    setter.setComponentFonts(smallAlpha);

    setSize(400, 250);
    setResizable(true);
    show();
  }

  /* ---------------- Functionality -------------------- */

  public void message (String arg)
  {
    msgArea_.append(arg + "\n");
  }
  
  public void clearMessages ()
  {
    msgArea_.setText("");
  }
  
  public String pathFromDialog (boolean writeTypeP)
  {
     FileDialog fd;
     fd = new FileDialog(this, null, (writeTypeP ? FileDialog.SAVE : FileDialog.LOAD));

     try {
       fd.show();
     } catch (Throwable e) {
       return null;
     }
     //Allow for variation in Java implementations
     String dir = fd.getDirectory();
     if (dir == null) {
       // User hit cancel probably.
       return null;
     }
     boolean haslash = dir.charAt(dir.length() - 1) == '/';
     String pathname_ = (dir + (haslash ? "" : "/") + fd.getFile());
     return pathname_;
  }


 
  /* ---------------- Listeners -------------------- */

  class MyWindowLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {

    }

    public void windowClosing (WindowEvent e)
    {

    }

    public void windowClosed (WindowEvent e)
    {

    }

    public void windowIconified (WindowEvent e)
    {

    }

    public void windowDeiconified (WindowEvent e)
    {
      
    }

    public void windowActivated (WindowEvent e)
    {
  
    }

    public void windowDeactivated (WindowEvent e)
    {
      
    }
  }
  
   /* ------------ File Menu ---------------- */
   
  class stopLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      if (sqJoiner_ != null) {
        sqJoiner_.abortJoin();
      }
    }
  }
   
  class quitLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      System.exit(0);
    }
  }

    // firstLNR lastLNR || brSrcLNR hvLNR brDestLNR doItLNR


   /* ------------ TIFF Menu ---------------- */
   
//    TiffPLNR  ResLNR
//  private boolean tiffP_ = false;
//  private int resolution_ = 72;

  class TiffPLNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      //lastCommandWasAdjust_ = false;
      if (event.getStateChange() == ItemEvent.DESELECTED)
        UseTiffP_ = false;
      else if (event.getStateChange() == ItemEvent.SELECTED)
        UseTiffP_ = true;
      else 
        message("RectFrame$TiffLNR unknown state.");
    }
  }
  
  class NoCmpLNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      //lastCommandWasAdjust_ = false;
      if (event.getStateChange() == ItemEvent.SELECTED) {
        TIFFCompression_ = TIFFEncoder.NO_COMPRESSION;
        PkBtMI_.setState(false);
      }
   }
  }

  class PkBCmpLNR implements ItemListener 
  {
    public void itemStateChanged(ItemEvent event)
    {
      //lastCommandWasAdjust_ = false;
      if (event.getStateChange() == ItemEvent.SELECTED) {
        TIFFCompression_ = TIFFEncoder.PACKBITS;
        NoCmpMI_.setState(false);
      }
    }
  }
  
   
  class ResLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      NumDialog numberBox = new NumDialog("Pixels Per Inch", self_,
                                           String.valueOf(resolution_));
      try {
        resolution_ = numberBox.getValue();
      } catch (NumberFormatException exc) {
        message("Error in reading PPI number.");
        message(exc.getMessage() == null ? exc.toString() : 
                exc.getMessage());
      }
    }
  }
  
  class CRtLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      NumDialog numberBox = new NumDialog("Copyright String", self_,
                                           copyRightNotice_);
      try {
        copyRightNotice_ = numberBox.getString();
      } catch (NumberFormatException exc) {
        message("Error in reading copyright string.");
        message(exc.getMessage() == null ? exc.toString() : 
                exc.getMessage());
      }
    }
  }
  
  class RwStrpLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      NumDialog numberBox = new NumDialog("Rows/Strip. Default=0", self_,
                                           String.valueOf(tiffRowsPerStrip_));
      try {
        tiffRowsPerStrip_ = numberBox.getValue();
      } catch (NumberFormatException exc) {
        message("Error in reading Rows per Strip number.");
        message(exc.getMessage() == null ? exc.toString() : 
                exc.getMessage());
      }
    }
  }
  

   /* ------------ Pathname Listeners ---------------- */
   
  class brSrcLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog(false);
      if (path1 != null)
        sourceField_.setText(path1);
    }
  }

  class brDestLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      String path1 = pathFromDialog(true);
      if (path1 != null)
        destinationField_.setText(path1);
    }
  }

  class doItLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      sqJoiner_ = new RectJoiner(sourceField_.getText(),
                                 vFirst_, vLast_, hFirst_, hLast_,
                                 destinationField_.getText());
      if (UseTiffP_) {
        sqJoiner_.useTiff(UseTiffP_);
        sqJoiner_.setTiffRowsPerStrip(tiffRowsPerStrip_);
        sqJoiner_.setCopyRightNotice_(copyRightNotice_);
        sqJoiner_.setResolution(resolution_);
        sqJoiner_.setTiffCompression(TIFFCompression_);
      } else {
        sqJoiner_.useTiff(UseTiffP_);
      }      
      sqJoiner_.join(self_);
      Thread runner = new Thread(sqJoiner_);
      runner.start();
      //System.gc();
    }
  }

  class firstHLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        hFirst_ = new Integer(firstHField_.getText()).intValue();
        firstHField_.setForeground(Color.black);
        //message("hFirst_ set to " + hFirst_);
      } catch (Throwable except) {
        firstHField_.setForeground(Color.red);
      }
    }
  }
  
  class lastHLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        hLast_ = new Integer(lastHField_.getText()).intValue();
        lastHField_.setForeground(Color.black);
        //message("hLast_ set to " + hLast_);
      } catch (Throwable except) {
        lastHField_.setForeground(Color.red);
      }
    }
  }
  
  class firstVLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        vFirst_ = new Integer(firstVField_.getText()).intValue();
        firstVField_.setForeground(Color.black);
        //message("vFirst_ set to " + vFirst_);
      } catch (Throwable except) {
        firstVField_.setForeground(Color.red);
      }
    }
  }
  
  class lastVLNR implements TextListener
  {
    public void textValueChanged(TextEvent event)
    {
      try {
        vLast_ = new Integer(lastVField_.getText()).intValue();
        lastVField_.setForeground(Color.black);
        //message("vLast_ set to " + vLast_);
      } catch (Throwable except) {
        lastVField_.setForeground(Color.red);
      }
    }
  }
  
  /* -------------- Entry Point ------------------ */
  
  public static void main(String[] args)
    // 
  {
     new RectFrame();
  }

  
}
