package JavaQuat20;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import java.net.URL;
import java.net.*;


public class URLSucker
{
  URLSucker self_ = null;
  SimpleMessageFrame msg_ = null;

  public static void main(String[] args)
    // I expect the first arg to be a pathname or URL
    // The second might be a width and the third a height
    // None of these would be required.
  {
    new URLSucker(args);
  }

  public URLSucker (String[] args) {
    System.out.println("Starting.");
    self_ = this;
    String url = null;
    String pathname = null;
    InputStream inStream = null;
    OutputStream outStream = null;
    msg_ = new SimpleMessageFrame("Messages", 500, 500);
    msg_.setVisible(true);
    JQIO utility = new JQIO(msg_, msg_);

    // Get url and output file.
    for (int i = 0; i < args.length; i++) {
      if (args[i].startsWith("http") || args[i].startsWith("ftp") || args[i].indexOf("://") > -1) {
	url = args[i].trim();
      } else {
	pathname = args[i].trim();
      }
    }
    if (url == null) {
      url = utility.urlStringFromDialog();
    }
    if (pathname == null) {
      pathname = utility.pathFromDialog(true);
    }

    // quit if we didn't get source and destination.
    if (pathname == null || url == null) {
      System.exit(0);
    }
    
    // Get streams
    try {
      inStream = utility.toInputStream(pathname, true, false); // true=>url, false => create stream.
      outStream = utility.toOutputStream(pathname, false, false);
    } catch (Throwable err) {
      msg_.message("Error opening files: "+err, true);
    }
    int byte1;
    long byteCount = 0;
    BufferedInputStream input = new BufferedInputStream(inStream);
    BufferedOutputStream output = new BufferedOutputStream(outStream);
    msg_.message("Begin Reading ...", true);
    try {
      while ((byte1 = input.read()) > -1) {
	output.write(byte1);
	if (++byteCount % 1000 == 0) {
	  msg_.message("Bytes = "+byteCount, false);
	}
      }
    } catch (Throwable err2) {
      msg_.message("Error reading files: "+err2, true);
    }
    msg_.message("Bytes read = "+byteCount, false);
    try {
      output.flush();
      output.close();
      input.close();
    } catch (Throwable err3) {
      msg_.message("Error closing files: "+err3, true);
    }
  }

  class SimpleMessageFrame extends Frame implements Messenger
  {
    private TextArea textArea_;
    public SimpleMessageFrame (String title, int width, int height) {
      super(title);
      setSize(width, height);
      addWindowListener(new MyWindowLNR());

      textArea_ = new TextArea();
      textArea_.setEditable(false);
      setLayout(new BorderLayout(0, 0));
      add(BorderLayout.CENTER, textArea_);

      Button exitButton = new Button("Exit");
      exitButton.addActionListener(new exitLNR());
      add(BorderLayout.SOUTH, exitButton);
    }
      
    public void message (String message, boolean show_p) {
      if (show_p) {
	setVisible(true);
      }
      textArea_.append("\n"+message);
    }
    public FastQuaternion parmsDAxis () { return null;}
    public FastQuaternion parmsWAxis () { return null;}
  }

  class exitLNR implements ActionListener
  {
    public void actionPerformed (ActionEvent e)
    {
      System.exit(0);
    } 
  }

  class MyWindowLNR implements WindowListener
  {
    public void windowOpened (WindowEvent e)
    {
      
    }

    public void windowClosing (WindowEvent e)
    {   
      msg_.setVisible(false);
    }

    public void windowClosed (WindowEvent e)
    {
      
    }

    public void windowIconified (WindowEvent e)
    {
      
    }

    public void windowDeiconified (WindowEvent e)
    {
      
    }

    public void windowActivated (WindowEvent e)
    {
      
    }

    public void windowDeactivated (WindowEvent e)
    {
      
    }
  }
}

